/*
 * Main.fx
 */

package pathtdemo;

import javafx.animation.Interpolator;
import javafx.animation.Timeline;

import javafx.animation.transition.AnimationPath;
import javafx.animation.transition.OrientationType;
import javafx.animation.transition.PathTransition;

import javafx.scene.Group;
import javafx.scene.Scene;

import javafx.scene.image.Image;
import javafx.scene.image.ImageView;

import javafx.scene.input.MouseEvent;

import javafx.scene.paint.Color;

import javafx.scene.shape.ArcTo;
import javafx.scene.shape.ClosePath;
import javafx.scene.shape.LineTo;
import javafx.scene.shape.MoveTo;
import javafx.scene.shape.Path;

import javafx.stage.Stage;

def car: ImageView = ImageView
{
    var carim: Image
    image: carim = Image { url: "{__DIR__}res/car.gif" }
    x: bind -carim.width/2
    y: bind 300-carim.height/2
    rotate: 90
}

def path =
[
    MoveTo { x: 0 y: 300 }
    ArcTo { x: 100 y: 400 radiusX: 100 radiusY: 100 }
    LineTo { x: 300 y: 400 }
    ArcTo { x: 400 y: 300 radiusX: 100 radiusY: 100 }
    LineTo { x: 400 y: 100 }
    ArcTo { x: 300 y: 0 radiusX: 100 radiusY: 100 }
    LineTo { x: 100 y: 0 }
    ArcTo { x: 0 y: 100 radiusX: 100 radiusY: 100 }
    LineTo { x: 0 y: 300 }
    ClosePath {}
];

def road = Path
{
    stroke: Color.BLACK
    strokeWidth: 75
    elements: path
}

def divider = Path
{
    stroke: Color.WHITE
    strokeWidth: 4
    strokeDashArray: [ 10, 10 ]
    elements: path
}

def anim = PathTransition
{
    node: car
    path: AnimationPath.createFromPath (road)
    orientation: OrientationType.ORTHOGONAL_TO_TANGENT
    interpolator: Interpolator.LINEAR
    duration: 6s
    repeatCount: Timeline.INDEFINITE
}

Stage
{
    title: "PathTransition Demo"
    width: 510
    height: 535

    scene: Scene
    {
        fill: Color.DARKGREEN

        content: Group
        {
            content: [ road, divider, car ]

            translateX: 50
            translateY: 50

            onMouseClicked: function (me: MouseEvent): Void
            {
                if (anim.running and not anim.paused)
                    anim.pause ()
                else
                    anim.play ()
            }
        }
    }
}