/*
 * Main.fx
 */

package pstdemo;

import javafx.animation.transition.FadeTransition;
import javafx.animation.transition.ParallelTransition;
import javafx.animation.transition.ScaleTransition;
import javafx.animation.transition.SequentialTransition;

import javafx.scene.Scene;

import javafx.scene.paint.Color;
import javafx.scene.paint.LinearGradient;
import javafx.scene.paint.RadialGradient;
import javafx.scene.paint.Stop;

import javafx.scene.shape.Circle;

import javafx.scene.text.Font;
import javafx.scene.text.Text;
import javafx.scene.text.TextOrigin;

import javafx.stage.Stage;

def BACKGROUND_PAINT = LinearGradient
{
    startX: 0.0
    startY: 0.0
    endX: 0.0
    endY: 1.0
    stops:
    [
        Stop { offset: 0.0 color: Color.BEIGE }
        Stop { offset: 1.0 color: Color.CORAL }
    ]
}

var circle: Circle;
var text: Text;

def FADEC_TRANSITION = FadeTransition
{
    node: bind circle
    fromValue: 1.0
    toValue: 0.0
    duration: 2s
    repeatCount: 4
    autoReverse: true
}

def FADETOUT_TRANSITION = FadeTransition
{
    node: bind text
    fromValue: 1.0
    toValue: 0.0
    duration: 4s
}

def FADETIN_TRANSITION = FadeTransition
{
    node: bind text
    fromValue: 0.0
    toValue: 1.0
    duration: 4s
}

def SCALEC_TRANSITION = ScaleTransition
{
    var count = 0
    node: bind circle
    fromX: 1.0
    fromY: 1.0
    toX: 0.25
    toY: 0.25
    duration: 2s
    repeatCount: 4
    autoReverse: true
    action: function (): Void
    {
        if (++count == 2)
            FADETIN_TRANSITION.playFromStart ()
    }
}

def PAR_TRANSITION = ParallelTransition
{
    content: [ FADEC_TRANSITION, SCALEC_TRANSITION ]
}

def SEQ_TRANSITION = SequentialTransition
{
    content: [ FADETOUT_TRANSITION, PAR_TRANSITION /*, FADETIN_TRANSITION */ ]
}

SEQ_TRANSITION.playFromStart ();

Stage
{
    title: "PSTransition Demo"
    width: 250
    height: 250

    var scene: Scene
    scene: scene = Scene
    {
        fill: BACKGROUND_PAINT

        content:
        [
            circle = Circle
            {
                centerX: bind scene.width/2
                centerY: bind scene.height/2
                radius: 90

                fill: RadialGradient
                {
                   centerX: 75
                   centerY: 75
                   radius: 90
                   proportional: false
                   stops:
                   [
                       Stop { offset: 0.0 color: Color.BLUE }
                       Stop { offset: 1.0 color: Color.DARKBLUE }
                   ]
                }
            }

            text = Text
            {
                x: bind circle.centerX
                y: bind circle.centerY
                translateX: bind -text.layoutBounds.width/2
                translateY: bind -text.layoutBounds.height/2
                textOrigin: TextOrigin.TOP

                fill: Color.WHITE
                font: Font
                {
                    name: "Arial BOLD"
                    size: 14
                }

                content: "PSTransition Demo"
            }
        ]
    }
}