/*
 * Main.fx
 */

package rotatetdemo;

import javafx.animation.Interpolator;
import javafx.animation.Timeline;

import javafx.animation.transition.RotateTransition;

import javafx.scene.Scene;

import javafx.scene.effect.Reflection;

import javafx.scene.input.MouseEvent;

import javafx.scene.paint.Color;

import javafx.scene.shape.Rectangle;

import javafx.scene.text.Font;
import javafx.scene.text.Text;
import javafx.scene.text.TextOrigin;

import javafx.stage.Stage;

Stage
{
    title: "RotateTransition Demo"
    width: 300
    height: 300

    var scene: Scene
    scene: scene = Scene
    {
        var text: Text

        def rt = RotateTransition
        {
            node: bind text
            fromAngle: 0
            toAngle: 360
            interpolate: Interpolator.LINEAR
            repeatCount: Timeline.INDEFINITE
            duration: 3s
        }

        content:
        [
            Rectangle
            {
                x: 0
                y: 0
                width: bind scene.width
                height: bind scene.height

                fill: Color.ORANGE

                onMouseClicked: function (me: MouseEvent): Void
                {
                    if (rt.running and not rt.paused)
                        rt.pause ()
                    else
                        rt.play ()
                }
            }

            text = Text
            {
                content: "JavaFX RotateTransition Demo"

                font: Font
                {
                    name: "Arial BOLD"
                    size: 16
                }

                textOrigin: TextOrigin.TOP
                translateX: bind (scene.width-text.layoutBounds.width)/2
                translateY: bind (scene.height-text.layoutBounds.height)/2

                effect: Reflection {}
            }
        ]
    }
}